#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tmesh.h"

#include "CGInterface.h"

class Scene {
public:

  // gpu programming
  CGInterface *cgi;
  ShaderOneInterface *soi;
  
  GUI *gui;
  FrameBuffer *fb, *texture, *hwfb;
  PPC *ppc, *ppc0, *ppc1;
  TMesh **tmeshes;
  int tmeshesN;

  bool hwInit; // false until graphics hardware rendering is initialized
  
  Scene();
  void DBG();
  void Render();
  void RenderHW();
  void FlagB();
  void SaveB();

  // animation parameters
  float animationFraction, animationRadius;
  V3 animationCenter;
  V3 light;

};

extern Scene *scene;
